<?php

// Page de configuration de l'outil MonFTPPerso v1.0 © Stéphan Bricogne.
// Fichier initial d'installation disponible sur http://www.bricogne.com/stephan/creation/monftpperso/
// Lisez d'abord le fichier "_installation_à_lire.txt" avant de modifier ce fichier.

// Configurez chaque ligne contenant une variable (commençant par $) avec les valeurs que vous aurez choisies.
// Vous n'avez que 11 variables à configurer.
// Attention, toute mauvaise saisie peut entraîner un mauvais fonctionnement de l'outil.


// Chemin du dossier partagé web (celui où se trouve votre répertoire web).
// C'est la seule partie vraiment difficile de la configuration de l'outil.
// Ex : Sur un serveur Synology, "/volume1/web/" semble fonctionner correctement (mais assurez-vous en).
// Ex : Sur l'hébergeur OVH, "/home/votre_nom_de_compte/www/" semble fonctionner correctement (mais assurez-vous en).
// Bien mettre le "/" à la fin.
$dossier_partage_web='/volume1/web/';


// Voilà, à partir de maintenant, la configuration redevient hyper-facile. ;)


// Adresse du serveur qui va héberger l'outil MonFTPPerso.
// Ex : http://www.monserveur.com/ (bien mettre le "/" à la fin).
// Vous pouvez mettre MonFTPPerso dans des sous répertoires comme http://www.monserveur.com/rep1/rep2/
$adresse_serveur='http://www.monserveur.com/';


// Nom du répertoire où se trouve le script MonFTPPerso.
// L'adresse à donner aux visiteurs pourra donc être http://www.monserveur.com/nom_du_repertoire_choisi
// Astuce : Il est possible d'installer autant d'instance de MonFTPPerso voulue en donnant autant de nom du répertoire et installant MonFTPPerso dans chacun de ces répertoires
// Exemple http://www.monserveur.com/nom1, http://www.monserveur.com/nom2, etc.
// Chaque instance pourra avoir sa langue propre, cf plus loin.
$nom_repertoire='nom_du_repertoire_choisi';


// Nom du répertoire où sont stockés les fichiers déposés (cf fichier installation.txt pour configurer les droits d'accès).
// De base il se nomme "fichiers" mais vous pouvez le renommer pour raison de sécurité.
// Vos fichiers seront donc dans http://www.monserveur.com/nom_du_repertoire_choisi/fichiers/
// Pour raison de sécurité, ne pas supprimer le fichier "index.html" qui s'y trouve dedans.
$repertoire_depot='fichiers';


// Titre qui sera affiché en grand en haut de la page, visible par les visiteurs.
$titre_page='Titre de MonFTPPerso';


// Langue par défaut de la page visible par vos visiteurs
// Deux choix seulement au 1er mai 2019
// "fr" si français / "en" si anglais.
// D'autres langues à venir... Un contrôle est fait par MonFTPPerso, si la langue n'est pas reconnue, l'Anglais sera mis par défaut.
$langue='fr';


// Taille maximale de télé-versement des fichiers.
// Attention, il faudra aussi modifier en conséquence les valeurs "post_max_size" et "upload_max_filesize" du php.ini de votre serveur (cherchez sur le net pour savoir comment modifier ces valeurs).
// La taille est en octet. Ex : 1mo s'écrit 1000000 (6 zéros), 100mo s'écrit 100000000 (8 zéros), 1go s'écrit 1000000000 (9 zéros).
// Pour une meilleure lisibilité, l'affichage pour le visiteur se fera automatiquement en mo.
$taille_max_fichier='100000000';


// Rajouter (ou pas) la date et heure de télé-versement des fichiers.
// MonFTPPerso rajoutera (ou pas) la date et l'heure sous le format 'AAAAMMJJ_HHmmSS_' devant le nom du fichier télé-versé.
// Cela permet d'éviter d'avoir 2 fichiers avec le même nom dans le répertoire de dépôt des fichiers.
// Attention : Si la variable est mise à 'non', si un utilisateur dépose un fichier dont le nom existe déjà, et que vous avez mis la valeur aléatoire à '0' (cf plus bas), l'ancien fichier sera automatiquement effacé.
// Il n'a que 2 possibilités pour cette variable : 'oui' ou 'non'.
// Par protection, si la variable n'a pas une de ces 2 valeurs possibles, MonFTPPerso corrigera par défaut avec 'oui'.
$mettre_date_fichier='oui';


// Rajouter (ou pas) un code aléatoire aux noms des fichiers télé-versés.
// MonFTPPerso rajoutera (ou pas) une chaîne de x lettres aléatoires à la fin du fichier télé-versé.
// Ce nombre x est défini par la variable $mettre_code_aleatoire_fichier='x', y pouvant aller de 0 (pas de code aléatoire) à 10.
// Par protection, si la variable n'est pas reconnue, MonFTPPerso corrigera par défaut avec '10'.
// Conseil de sécurité : il est préférable de mettre cette valeur supérieure à 0 car cela change le nom du fichier.
// Car en connaissant le nom exact du fichier et sa localisation, une personne malveillante pourrait télé-verser un fichier contenant un script et le lancer directement depuis votre serveur.
$mettre_code_aleatoire_fichier='5';


// Mot de passe de la porte dérobée
// Permettra de vous afficher les fichiers déposés par une interface web classique pour les cas où vous ne pouvez accéder à votre serveur directement.
// (depuis un réseau d'entreprise par exemple ou si l'interface gestion de votre serveur n'est pas pratique par votre téléphone portable).
// Plus le mot de passe sera long, plus la sécurité sera accrue.
// Ne donner ce mot de passe qu'à une personne de confiance.
// Pour ne pas bénéficier de cette fonction, mettre la variable vide : $porte='';
// L'accès se fera par http://www.monserveur.com/nom_du_repertoire_choisi/?porte=mdp_choisi
$porte='';


// Adresse courriel de la personne qui recevra la notification de dépôt de fichier (et qui sera l'expéditrice du message).
// Si vous souhaitez pas bénéficier de cette fonction ou si votre serveur n'est pas configuré pour envoyer des courriels, alors laissez la variable vide : $courriel='';
// Pour envoyer un message à plusieurs personnes, mettre une virgule entre chaque adresse (l'expéditrice du message sera la première adresse).
// Ex : $courriel='toto@serveur.fr,titi@adresse.fr';
$courriel='';

?>