<!DOCTYPE html>
<!-- MonFTPPerso © Stéphan Bricogne (http://www.bricogne.com/stephan) version 1.0 du 6 mai 2019 -->
<!-- Fichier initial d'installation disponible sur http://www.bricogne.com/stephan/creation/monftpperso/ -->
<?php
$version_actuelle='1.0';
require "configuration.php";

// /!\ Cette condition est à modifier dès qu'une nouvelle langue est disponible /!\
if ($langue!='fr' && $langue!='en') { // Si l'utilisateur s'est trompé dans la variable langue, on met le EN par défaut
	$langue='en';
}

require "messages_".$langue.".php"; // Appelle le fichier qui contient tous les messages affichés à l'écran, mais dans la langue choisie dans la configuration

if ($mettre_date_fichier!='oui' && $mettre_date_fichier!='non') { // Si l'utilisateur s'est trompé dans la variable mettre_date_fichier, on met le OUI par défaut
	$mettre_date_fichier='oui';
}
if ($mettre_code_aleatoire_fichier<'1') { // Si l'utilisateur s'est trompé dans la variable mettre_code_aleatoire_fichier, on met au moins 0
	$mettre_code_aleatoire_fichier='0';
}
if ($mettre_code_aleatoire_fichier>'10') { // Si l'utilisateur s'est trompé dans la variable mettre_code_aleatoire_fichier, on met 10 par défaut
	$mettre_code_aleatoire_fichier='10';
}
?>
<html lang="<?php echo $langue; ?>">
<head>
	<meta charset="utf-8" />
	<title><?php echo $titre_page; ?></title>
	<link rel="stylesheet" href="style.css" />
<?php
// Les 3 lignes qui suivent devront être mises en commentaires (avec "//" devant) si vous avez le bug suivant sur votre site "Parse error: syntax error, unexpected T_CONST, expecting T_OLD_FUNCTION or T_FUNCTION or T_VAR or '}' in /home/xxx/Mobile_Detect.php on line 34"
require_once 'Mobile_Detect.php';
$detect = new Mobile_Detect();
if ($detect->isMobile()) {echo '	<link rel="stylesheet" href="style_mobile.css" />'."\n";} // Si MonFTPPerso reconnaît que c'est un téléphone portable, on charge le CSS pour téléphone
?>
	<link rel="icon" href="icone.png" type="image/png" sizes="32x32" />
	<meta name="Description" lang="<?php echo $langue; ?>" content="<?php echo $titre_page.$message_metatag_description.' MonFTPPerso © Stéphan Bricogne (http://www.bricogne.com/stephan)'; ?>" />
	<meta name="Date" content="31/03/2019" />
	<meta name="Date-Creation-yyyymmdd" content="20190331" />
	<meta name="Date-Revision-yyyymmdd" content="20190506" />
	<meta name="Author" lang="fr" content="Stéphan Bricogne (http://www.bricogne.com/stephan)" />
	<meta name="Publisher" lang="<?php echo $langue; ?>" content="Stéphan Bricogne (http://www.bricogne.com/stephan) <?php echo $message_mot_pour.' '.$adresse_serveur.$nom_repertoire; ?>" />
	<meta name="Copyright" lang="<?php echo $langue; ?>" content="Stéphan Bricogne (http://www.bricogne.com/stephan) <?php echo $message_mot_pour.' '.$adresse_serveur.$nom_repertoire; ?>" />
	<meta name="Identifier-URL" content="<?php echo $adresse_serveur; ?><?php echo $nom_repertoire; ?>" />
	<meta name="Reply-to" content="" />
	<meta name="Category" content="Outil de FTP Personnel / Personal FTP Tool" />
	<meta name="Generator" content="Notepad++" />
	<meta name="robots" content="noindex, nofollow" />
	<meta name="revisit-after" content="none" />
</head>

<body>

<header>
<h1><?php echo $titre_page; ?></h1><br />
	<nav>
	</nav>
</header>

<section>
	<article>

<?php
$mdp=$_GET['porte']; // Récupère la valeur de porte dans l'adresse pour voir si on laisse l'accès au listage du répertoire (fonction porte dérobée)

function formate_taille($langue, $bytes, $decimals = 0) { // $decimals = x où x est le nbre après la virgule
// /!\ Cette condition est à modifier dès qu'une nouvelle langue est disponible /!\
if ($langue=="fr") {
	$size = array('o','ko','mo','go','to','po','eo','zo','yo');
	}
if ($langue=="en") {
	$size = array('b','kb','mb','gb','tb','pb','eb','zb','yb');
}
	$factor = floor((strlen($bytes) - 1) / 3);
	return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$size[$factor];
}

// $element_du_fichier = pathinfo($fichier_nom_avec_date) puis $element_du_fichier['filename'] ne fonctionne pas avant PHP 5.2.0
// J'utilise la fonction nom_fichier_sans_extention($file) trouvée sur https://www.php.net/manual/fr/function.pathinfo.php
function nom_fichier_sans_extention($file) { // "file.name.ext" retourne "file.name"
	if (defined('PATHINFO_FILENAME')) return pathinfo($file,PATHINFO_FILENAME);
	if (strstr($file, '.')) return substr($file,0,strrpos($file,'.'));
}

function genere_chaine_aleatoire($length=20){ // Rajoute un code aléatoire composé de 1 à 10 lettres (raison de sécurité)
	$chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$string='';
	for($i=0; $i<$length; $i++){
		$string.=$chars[rand(0, strlen($chars)-1)];
	}
	return $string;
}

function get_ip() { // Retourne l'adresse IP de la personne qui dépose le fichier (envoyée par mail)
	if (isset($_SERVER['HTTP_CLIENT_IP'])) {
		return $_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		return $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else {
		return (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '');
	}
}

//
// Début de la porte dérobée
//
if ($mdp==$porte && $mdp!='') { // Si le code de la porte correspond à celui qui est dans le fichier de configuration ou s'il est différent de '' (cas où l'utilisateur ne veut pas de la fonction porte dérobée) alors on rentre dans la routine d'affichage du répertoire

	echo '<div class="porte_derobee">';
	if($dossier_televerse = opendir('./'.$repertoire_depot)) { // On ouvre le répertoire où se trouvent les fichiers.
		$nb_fichier='0';
		while(false !== ($fichier_televerse = readdir($dossier_televerse))) { // S'il n'y a pas d'erreur dans l'ouverture du répertoire
			if($fichier_televerse != '.' && $fichier_televerse != '..' && $fichier_televerse != 'index.php' && $fichier_televerse != 'index.html') { // On ne prend pas en compte certains fichiers
				$liste_fichier[$nb_fichier]=$fichier_televerse; // On stocke chaque nom de fichier dans le tableau $liste_fichier
				$nb_fichier++;
			}
		}
		closedir($dossier_televerse);
		
		echo '<span class="porte_derobee_label_affiche_version">'.$message_porte_affiche_version.'</span> <span class="porte_derobee_valeur_affiche_version">'.$version_actuelle.'</span><br /><br />'; // Message : Version actuelle

		echo '<span class="porte_derobee_label_nbre_fichier">'.$message_porte_nbre_fichier.'</span> <span class="porte_derobee_valeur_nbre_fichier">'.$nb_fichier.'</span><br />'; // Message : Nombre de fichier

		if(count($liste_fichier)!=0) { // Si le tableau $liste_fichier n'est pas vide
			sort($liste_fichier); // Alors on le trie par ordre alphabétique
		}

		echo '<ul>';
		$compteur=0;
		while ($compteur<count($liste_fichier)) { // On affiche ligne par ligne le contenu du tableau $liste_fichier
			echo '<li><a href="./'.$repertoire_depot.'/'.$liste_fichier[$compteur].'" onclick="window.open(this.href); return false;" class="normale">'.$liste_fichier[$compteur].'</a> <span class="porte_derobee_valeur_taille_fichier">('.formate_taille($langue,filesize('./'.$repertoire_depot.'/'.$liste_fichier[$compteur])).')</span></li>';
			$compteur++;
		}
		echo '</ul>';
		
	} else { // S'il y a une erreur dans l'ouverture du répertoire
		 echo '<span class="important">'.$message_porte_erreur_ouverture.'</span><br /><br />'; // Message : Le dossier n'a pas pu être ouvert
	}
	echo '<a href="." class="normale">'.$message_porte_retour.'</a></div>'; // Message : Retour à la page principale
} else { // Si le code de la porte n'est pas celui de la porte dérobée, alors on lance le formulaire de dépôt de fichier
//
// fin de la porte dérobée
//

//
// Début du dépôt
//
	echo '<div class="depot">';
	if ($_POST['formulaire']=="soumis") {

//
// Début du dépôt si le fichier a été soumis
//
		$extension=substr($_FILES['fichier']['name'], -3);

		if ($extension=="php" || $extension=="exe" || $extension==".sh" || $extension=="tml" || $extension=="htm") { // Si le fichier a une extension "dangereuse", on empêche de le mettre sur le serveur
			echo '<div class="important">'.$message_depot_interdit.'</div><br />'; // Message : Désolé, ce type de fichier est interdit pour raison de sécurité.
		}
		else { // Sinon si c'est une extension autorisée, on continue
			$date_depot_fichier=date("Ymd_His").'_';
			if ($mettre_date_fichier=="non") { // Si on a mis la variable qui refuse la date du dépôt, on la supprime
				$date_depot_fichier='';
			}

			$fichier_nom=$_FILES['fichier']['name']; // On récupère le nom original du fichier
			// Et on remplacer les lettres accentuées par des non-accentuées (pour éviter des problèmes de nom des fichiers, on ne sait jamais)
			$fichier_nom=strtr($fichier_nom,
				'ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
				'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy'); 
			// Expression régulière remplaçant tout ce qui n'est pas une lettre non accentuées ou un chiffre par un underscore (pour éviter des problèmes de caractères spéciaux dans le nom des fichiers, on ne sait jamais)
			$fichier_nom=preg_replace('/([^.a-z0-9]+)/i', '_', $fichier_nom);

			$fichier_extension=$_FILES['fichier']['type']; // On récupère le type du fichier, ex image/png

			$fichier_size=$_FILES['fichier']['size']; // On récupère la taille du fichier en octets

			$fichier_localisation=$_FILES['fichier']['tmp_name']; // On récupère l'adresse du fichier déposé dans le répertoire temporaire

			$fichier_erreur=$_FILES['fichier']['error']; // On récupère le code d'erreur, permet de savoir si le fichier a bien été déposé

			if(isset($_FILES['fichier'])) { 
				$dossier=$dossier_partage_web.$nom_repertoire.'/./'.$repertoire_depot.'/'; // Localisation où on veut déposer le fichier (il faut bien mettre http://www.monserveur.com/nom_du_repertoire_choisi/./$repertoire_fichier/, le /./ est obligatoire)
				$fichier_nom_avec_date=$date_depot_fichier.basename($fichier_nom);
				if ($mettre_code_aleatoire_fichier>'0') { // Si la paramètre partie aléatoire est activée
				$element_du_fichier = pathinfo($fichier_nom_avec_date); // On éclate les différentes parties du nom du fichier dans le tableau element_du_fichier
				// $element_du_fichier['filename'] ne fonctionne pas avant PHP 5.2.0
				// J'utilise la fonction nom_fichier_sans_extention($file) trouvée sur https://www.php.net/manual/fr/function.pathinfo.php
				// qui contourne cette restriction
				$fichier_nom_avec_date=nom_fichier_sans_extention($fichier_nom_avec_date).'_'.genere_chaine_aleatoire($mettre_code_aleatoire_fichier).'.'.$element_du_fichier['extension']; // On rajoute _XXX juste avant l'extension
				// À la place de genere_chaine_aleatoire(4), j'aurais pu mettre "sprintf('%04s',rand (0, 9).rand (0, 9).rand (0, 9).rand (0, 9)).'.'.$element_du_fichier['extension']" pour avoir 4 digits aléatoires de 0000 à 9999
				// sinon, si on est en PHP 5.2.0+ on peut mettre $element_du_fichier['filename'] et ne pas utiliser la fonction nom_fichier_sans_extention($fichier_nom_avec_date)
				}

				echo $message_depot_nom.' : <span class="nom_fichier">'.$fichier_nom.'</span><br />'; // Message : Nom du fichier 
				//echo 'Extension du type : <b>'.$fichier_extension.'</b><br />';
				echo $message_depot_taille.' : <span class="taille_fichier">'.$fichier_size.'</span><br />'; // Message : Taille (octet)

				//echo '<i>Localisation temporaire : <b>'.$fichier_localisation.'</b></i><br />';
				//echo 'Code erreur (0=ok) : <b>'.$fichier_erreur.'</b><br />';
				echo '<br />';

				$trop_grand='0'; // Certaines versions PHP ne prennent pas en compte le MAX_FILE_SIZE du formulaire. Aussi pour être sûr, je mets mon propre contrôle sur la taille du fichier
				// Pour info, il se trouve que si de base la version PHP gère cette valeur, ce test n'est pas fait.
				if ($fichier_size>$_POST['MAX_FILE_SIZE']) {
					$trop_grand='1';
					echo '<div class="important">'.$message_depot_echoue.'</div>'; // Message : Dépôt du fichier échoué.
				}

				if ($trop_grand=='0') { // Si on n'a pas déjà dit que le fichier était trop grand (parce que justement il est plus petit que la taille autorisée), on le dépose
					if(move_uploaded_file($fichier_localisation, $dossier . $fichier_nom_avec_date)) { //Si la fonction renvoie TRUE, c'est que ça a fonctionné...
						echo '<div class="important">'.$message_depot_succes.'</div>'; // Message : Dépôt du fichier effectué avec succès.
						// Début du courriel
						if ($courriel!='') { // Si le champs courriel a été rentré dans le fichier de configuration
							$passage_ligne="\r\n";
							$courriel_exp = explode(",", $courriel);
							// Création du header du mail
							$header='From: "'.$courriel_exp[0].'" <'.$courriel_exp[0].'>'.$passage_ligne;
							$header.='Reply-to: "'.$courriel_exp[0].'" <'.$courriel_exp[0].'>'.$passage_ligne;
							// Création du sujet et du message du mail
							$sujet='[MonFTPPerso]['.$nom_repertoire.'] '.$message_courriel_nouveau_fichier; // Message : Nouveau fichier déposé
							$message_txt=$message_courriel_ip.' '.get_ip().' '.$message_courriel_a_depose.' '.$adresse_serveur.$nom_repertoire.'/'.$repertoire_depot.'/'.$fichier_nom_avec_date; // Message : a déposé le fichier
							$message_txt=$message_txt.' ('.formate_taille($langue,filesize('./'.$repertoire_depot.'/'.$fichier_nom_avec_date)).')'; // Rajoute la taille du fichier dans le courriel
							mail($courriel,$sujet,$message_txt,$header);
						}
						// Fin du courriel
					}
					else { //Sinon (la fonction renvoie FALSE).
						echo '<div class="important">'.$message_depot_echoue.'</div>'; // Message : Dépôt du fichier échoué.
					}
				}
			}
			echo '<br /><br />'.$message_depot_autre_fichier.'<br /><br />'; // Message : Un autre fichier ?
		}
	}
//
// Fin du dépôt si le fichier a été soumis
//
	echo '<fieldset>';
	echo '<legend>'.$message_general_taille_max.': '.number_format(($taille_max_fichier/1000000), 0, ',', ' ').'</legend>'; // Message : Taille maximale autorisée (octet)
	echo '<form method="post" action="." enctype="multipart/form-data">';
	echo '<input type="hidden" name="MAX_FILE_SIZE" value="'.$taille_max_fichier.'" />'; // Limite le volume d'envoi, en octet
	echo '<input type="file" name="fichier" /><br />';
	echo '<input type="hidden" name="formulaire" value="soumis" />';
	echo '<input type="submit" name="submit" value="'.$message_general_submit.'" />'; // Message : Déposer ce fichier
	echo '</form>';
	echo '</fieldset>';
	echo '</div>';
//
// Fin du dépôt
//
}
?>


	</article>
</section>

<footer>

<?php
// À partir de maintenant on parse le fichier XML.
// J'aurais pu utiliser la fonction $simpleXml mais elle valide que sur PHP 5+
// Donc je fais à l'"ancienne".
$fichier_version = fopen ("http://www.bricogne.com/stephan/creation/monftpperso/MonFTPPerso.xml", "r"); // On ouvre le fichier XML

if (!$fichier_version) { // Si le serveur du XML ne répond pas
	echo '<span class="pied_de_page_signature">'.$message_footer_xml_alerte.'</span>'; // Message : Souci XML
	echo '

</footer>

</body>
</html>';
	exit;
}

while (!feof ($fichier_version)) { // Tant qu'on n'est pas à la fin du fichier XML
	$ligne_fichier = fgets ($fichier_version); // On lit ligne par ligne le fichier
	
	preg_match ("@\<numero_version\>(.*)\</numero_version\>@i", $ligne_fichier, $xml_contenu); // On stocke dans le tableau $xml_contenu ce qu'il y a dans le marqueur XML "numero_version"
	if ($xml_contenu[0]!='') { // Si ce marqueur contient quelque chose
		$xml_numero_version=$xml_contenu[0];
		$xml_numero_version=str_replace('<numero_version>','',$xml_numero_version); // On retire le marqueur ouvrant
		$xml_numero_version=str_replace('</numero_version>','',$xml_numero_version); // On retire le marqueur fermant
	}
	preg_match ("@\<lien\>(.*)\</lien\>@i", $ligne_fichier, $xml_contenu); // Lien générique de MonFTPPerso
	if ($xml_contenu[0]!='') {
		$xml_lien=$xml_contenu[0];
		$xml_lien=str_replace('<lien>','',$xml_lien);
		$xml_lien=str_replace('</lien>','',$xml_lien);
	}
	preg_match ("@\<lien_fichier\>(.*)\</lien_fichier\>@i", $ligne_fichier, $xml_contenu); // Lien direct du fichier MonFTPPerso.zip
	if ($xml_contenu[0]!='') {
		$xml_lien_fichier=$xml_contenu[0];
		$xml_lien_fichier=str_replace('<lien_fichier>','',$xml_lien_fichier);
		$xml_lien_fichier=str_replace('</lien_fichier>','',$xml_lien_fichier);
	}
// /!\ Cette condition est à modifier dès qu'une nouvelle langue est disponible /!\
	if ($langue=="fr") { // Quelque soit la version de MonFTPPerso, on affiche le commentaire générique du XML, s'il est présent
		preg_match ("@\<commentaire_footer_fr\>(.*)\</commentaire_footer_fr\>@i", $ligne_fichier, $xml_contenu);
		if ($xml_contenu[0]!='') {
			$xml_commentaire_footer=$xml_contenu[0];
			$xml_commentaire_footer=str_replace('<commentaire_footer_fr>','',$xml_commentaire_footer);
			$xml_commentaire_footer=str_replace('</commentaire_footer_fr>','',$xml_commentaire_footer);
		}
		} else { // Par défaut, si MonFTPPerso n'est pas en FR, on affiche le texte en EN, comme ça évite de mettre des commentaires dans toutes les langues dans le XML : soit FR, soit EN par défaut
		preg_match ("@\<commentaire_footer_en\>(.*)\</commentaire_footer_en\>@i", $ligne_fichier, $xml_contenu);
		if ($xml_contenu[0]!='') {
			$xml_commentaire_footer=$xml_contenu[0];
			$xml_commentaire_footer=str_replace('<commentaire_footer_en>','',$xml_commentaire_footer);
			$xml_commentaire_footer=str_replace('</commentaire_footer_en>','',$xml_commentaire_footer);
		}
	}
}

fclose($fichier_version); // On ferme le fichier

$pied_de_page=$titre_page.$message_metatag_description.' <a href="'.$xml_lien.'" onclick="window.open(this.href); return false;" class="pied_de_page_lien_generique">MonFTPPerso</a> v'.$version_actuelle; // Message : , fonctionnant sous

echo '<span class="pied_de_page_signature">'.$pied_de_page.'</span>';

if ($version_actuelle!=$xml_numero_version) {
	echo '<br /><span class="pied_de_page_version"><a href="'.$xml_lien_fichier.'" onclick="window.open(this.href); return false;" class="pied_de_page_lien_version">'.$message_footer_xml_nouvelle_version.'</a></span>'; // Message : nouvelle version MonFTPPerso disponible
}

if ($xml_commentaire_footer!='') {
	echo '<br /><span class="pied_de_page_commentaire">'.$xml_commentaire_footer.'</span>'; // Affiche un commentaire générique qui se trouve dans le XML
}
?>


</footer>

</body>
</html>